//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadpcltopdfDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pcltopdf.dll");

	m_hinstLib = LoadLibrary(path);
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMAddFiles = (MAddFiles *)GetProcAddress(m_hinstLib, "MAddFiles");
	if( pMAddFiles == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMConvertAll = (MConvertAll *)GetProcAddress(m_hinstLib, "MConvertAll");
	if( pMConvertAll == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMEncrypt = (MEncrypt *)GetProcAddress(m_hinstLib, "MEncrypt");
	if( pMEncrypt == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMInformation = (MInformation *)GetProcAddress(m_hinstLib, "MInformation");
	if( pMInformation == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
   
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreepcltopdfDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadpcltopdfDll() == FALSE ){
		ShowMessage("Load pcltopdf.dll failed!");
		return;
	}

	char infile[256],infile2[256],outfile[256];
	GetModulePath(infile,"test.pcl");
	GetModulePath(infile2,"test2.px3");
	GetModulePath(outfile,"combine.pdf");

	long id = pMBegin();
	if(id>0){
		long level = 40;
		long printing = 1;
		long copying = 1;
		long changing = 0;
		long adding = 0;
		//Set PDF Encrypt
		pMEncrypt(id,"password","password2",level,printing,copying,changing,adding);
		
		//Add files
		pMAddFiles(id,infile);
		pMAddFiles(id,infile2);

		//Combine all files into one pdf file
		pMConvertAll(id,outfile);
		pMEnd(id);
	}	

	FreepcltopdfDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadpcltopdfDll() == FALSE ){
		ShowMessage("Load pcltopdf.dll failed!");
		return;
	}

	char infile[256],outfile[256];
	GetModulePath(infile,"test.pcl");
	GetModulePath(outfile,"test.pdf");

	long id = pMBegin();
	if(id>0){
		//Set PDF Information
		pMInformation(id,"title","subject","author","keywords","creator","producer");

		//Set Page Orientation
		pMSetParam(id,PARAM_ROTATE,NULL,NULL,90,0);
		//Set X and Y Resolution
		pMSetParam(id,PARAM_DPI,NULL,NULL,300,300);
		//Set page size
		pMSetParam(id,PARAM_SIZE,"a4",NULL,0,0);

		pMConvert(id,infile,outfile);
		pMEnd(id);
	}

	FreepcltopdfDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	if( LoadpcltopdfDll() == FALSE ){
		ShowMessage("Load pcltopdf.dll failed!");
		return;
	}

	char infile[256],outfile[256];
	GetModulePath(infile,"test2.px3");
	GetModulePath(outfile,"test_pdfa.pdf");

	long id = pMBegin();
	if(id>0){
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		long angle=0;
		long xoff=0;
		long yoff=0;
        long background=1;
		//Stamping
		pMWatermark(id,"PDFA document",fsize,fcolor,position,angle,xoff,yoff,background);

		//Create a PDFA document
		pMSetParam(id,PARAM_PDFA,NULL,NULL,1,0);

		pMConvert(id,infile,outfile);
		pMEnd(id);
	}

	FreepcltopdfDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------

