unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
  PARAM_ROTATE	= 100;
  PARAM_DPI		= 101;
  PARAM_SIZE	= 102;
  PARAM_PDFA	= 200;

type
  MBegin = function():Longint; stdcall;
  MEnd = function(id:Longint):Longint; stdcall;
  MConvert = function(id:Longint;infile:PChar;outfile:PChar):Longint; stdcall;
  MConvertAll = function(id:Longint;outfile:PChar):Longint; stdcall;
  MAddFiles = function(id:Longint;infile:PChar):Longint; stdcall;
  MEncrypt = function(id:Longint;userpassword:PChar;ownerpassword:PChar;encryptlevel:Longint;printing:Longint;copying:Longint;changing:Longint;adding:Longint):Longint; stdcall;
  MInformation = function(id:Longint;title:PChar;subject:PChar;author:PChar;keywords:PChar;creator:PChar;producer:PChar):Longint; stdcall;
  MWatermark = function(id:Longint;text:PChar;fsize:Longint;fcolor:Longint;position:Longint;angle:Longint;xoff:Longint;yoff:Longint;background:Longint):Longint; stdcall;
  MSetParam = function(id:Longint;index:Longint;sparam:PChar;sparam2:PChar;iparam:Longint;iparam2:Longint):Longint; stdcall;


  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    m_hDll:HMODULE;
		pMBegin:MBegin;
		pMEnd:MEnd;
    pMConvert:MConvert;
    pMConvertAll:MConvertAll;
    pMAddFiles:MAddFiles;
    pMEncrypt:MEncrypt;
    pMInformation:MInformation;
    pMWatermark:MWatermark;
    pMSetParam:MSetParam;

    function LoadDLL():BOOL;
    function FreeDLL():BOOL;    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function TForm1.LoadDLL():BOOL;
var
   sDllFile: PAnsiChar;
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
   sDllFile := 'pcltopdf.dll';
   m_hDll := LoadLibrary(sDllFile);
   if m_hDll = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(m_hDll, 'MBegin');
	 if pFunc = nil then goto ERR_FLAG;
   pMBegin := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MEnd');
	 if pFunc = nil then goto ERR_FLAG;
   pMEnd := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MConvert');
	 if pFunc = nil then goto ERR_FLAG;
   pMConvert := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MConvertAll');
	 if pFunc = nil then goto ERR_FLAG;
   pMConvertAll := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MAddFiles');
	 if pFunc = nil then goto ERR_FLAG;
   pMAddFiles := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MEncrypt');
	 if pFunc = nil then goto ERR_FLAG;
   pMEncrypt := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MInformation');
	 if pFunc = nil then goto ERR_FLAG;
   pMInformation := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MWatermark');
	 if pFunc = nil then goto ERR_FLAG;
   pMWatermark := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MSetParam');
	 if pFunc = nil then goto ERR_FLAG;
   pMSetParam := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;

function TForm1.FreeDLL():BOOL;
begin
	if m_hDll <> 0  then
  begin
     FreeLibrary(m_hDll);
     m_hDll := 0;
  end;
	Result := TRUE;
end;
procedure TForm1.Button1Click(Sender: TObject);
var
  infile:PAnsiChar;
  infile2:PAnsiChar;
  outfile:PAnsiChar;
  id:Longint;

  level:Longint;
  printing:Longint;
  copying:Longint;
  changing:Longint;
  adding:Longint;

begin
	if LoadDLL() = FALSE then
  begin
    ShowMessage('Load pcltopdf.dll failed!');
		exit;
	end;

  infile := Pchar(ExtractFileDir(ParamStr(0))+'/test.pcl');
  infile2 := Pchar(ExtractFileDir(ParamStr(0))+'/test2.px3');
  outfile := Pchar(ExtractFileDir(ParamStr(0))+'/combine.pdf');

  id := pMBegin();
	if id > 0 then
  begin
		level := 40;
		printing := 1;
		copying := 1;
		changing := 0;
		adding := 0;
		//Set PDF Encrypt
		pMEncrypt(id,'password','password2',level,printing,copying,changing,adding);
		
		//Add files
		pMAddFiles(id, infile);
		pMAddFiles(id, infile2);

		//Combine all files into one pdf file
		pMConvertAll(id, outfile);
  
		pMEnd(id);
	end;
  FreeDLL();
  ShowMessage('Convert finished!');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  infile:PAnsiChar;
  outfile:PAnsiChar;
  id:Longint;
begin
	if LoadDLL() = FALSE then
  begin
    ShowMessage('Load pcltopdf.dll failed!');
		exit;
	end;

  infile := Pchar(ExtractFileDir(ParamStr(0))+'/test.pcl');
  outfile := Pchar(ExtractFileDir(ParamStr(0))+'/test.pdf');

  id := pMBegin();
	if id > 0 then
  begin
		//Set PDF Information
		pMInformation(id,'title','subject','author','keywords','creator','producer');

		//Set Page Orientation
		pMSetParam(id,PARAM_ROTATE,'','',90,0);
		//Set X and Y Resolution
		pMSetParam(id,PARAM_DPI,'','',300,300);
		//Set page size
		pMSetParam(id,PARAM_SIZE,'a4','',0,0);

		pMConvert(id,infile,outfile);
		pMEnd(id);
	end;
  FreeDLL();
  ShowMessage('Convert finished!');
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  infile:PAnsiChar;
  outfile:PAnsiChar;
  id:Longint;

  fsize:Longint;
  fcolor:Longint;
  position:Longint;
  angle:Longint;
  xoff:Longint;
  yoff:Longint;
  background:Longint;

begin
	if LoadDLL() = FALSE then
  begin
    ShowMessage('Load pcltopdf.dll failed!');
		exit;
	end;

  infile := Pchar(ExtractFileDir(ParamStr(0))+'/test2.px3');
  outfile := Pchar(ExtractFileDir(ParamStr(0))+'/test_pdfa.pdf');

  id := pMBegin();
	if id > 0 then
  begin
		fsize:=16;
		fcolor:=255;//red
		position:=2;//Top-Center
		angle:=0;
		xoff:=0;
		yoff:=0;
		background:=1;
		//Stamping
		pMWatermark(id,'PDFA document',fsize,fcolor,position,angle,xoff,yoff,background);

		//Create a PDFA document
		pMSetParam(id,PARAM_PDFA,'','',1,0);

		pMConvert(id,infile,outfile);
		pMEnd(id);
	end;
  FreeDLL();
  ShowMessage('Convert finished!');
end;

end.
 