﻿Public Class Form1
    Private Declare Function MBegin Lib "pcltopdf.dll" () As Integer
    Private Declare Function MAddFiles Lib "pcltopdf.dll" (ByVal id As Integer, ByVal infile As String) As Integer
    Private Declare Function MConvert Lib "pcltopdf.dll" (ByVal id As Integer, ByVal infile As String, ByVal output As String) As Integer
    Private Declare Function MConvertAll Lib "pcltopdf.dll" (ByVal id As Integer, ByVal outfile As String) As Integer

    Private Declare Function MEncrypt Lib "pcltopdf.dll" (ByVal id As Integer, ByVal userpassword As String, ByVal ownerpassword As String,
                                                          ByVal encryptlevel As Integer, ByVal printing As Integer, ByVal copying As Integer,
                                                          ByVal changing As Integer, ByVal adding As Integer) As Integer

    Private Declare Function MInformation Lib "pcltopdf.dll" (ByVal id As Integer, ByVal title As String, ByVal subject As String, ByVal author As String,
                                                         ByVal keywords As String, ByVal creator As String, ByVal producer As String) As Integer

    Private Declare Function MWatermark Lib "pcltopdf.dll" (ByVal id As Integer, ByVal text As String, ByVal fsize As Integer, ByVal fcolor As Integer,
                                                           ByVal position As Integer, ByVal angle As Integer, ByVal xoff As Integer, ByVal yoff As Integer, ByVal background As Integer) As Integer

    Private Declare Function MEnd Lib "pcltopdf.dll" (ByVal id As Integer) As Integer
    Private Declare Function MSetParam Lib "pcltopdf.dll" (ByVal id As Integer, ByVal index As Integer, ByVal sparam As String, ByVal sparam2 As String, ByVal iparam As Integer, ByVal iparam2 As Integer) As Integer

    Const PARAM_ROTATE = 100
    Const PARAM_DPI = 101
    Const PARAM_SIZE = 102
    Const PARAM_PDFA = 200

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim id As Integer
        Dim level As Integer
        Dim printing As Integer
        Dim copying As Integer
        Dim changing As Integer
        Dim adding As Integer

        Dim inFile As String = Application.StartupPath + "\test.pcl"
        Dim inFile2 As String = Application.StartupPath + "\test2.px3"
        Dim outFile As String = Application.StartupPath + "\combine.pdf"

        id = MBegin()
        If (id > 0) Then
            level = 40
            printing = 1
            copying = 1
            changing = 0
            adding = 0
            'Set PDF Encrypt
            MEncrypt(id, "password", "password2", level, printing, copying, changing, adding)

            'Add files
            MAddFiles(id, inFile)
            MAddFiles(id, inFile2)

            'Combine all files into one pdf file
            MConvertAll(id, outFile)
            MEnd(id)
        End If

        MsgBox("Convert finished!")
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Dim id As Integer
        Dim inFile As String = Application.StartupPath + "\test.pcl"
        Dim outFile As String = Application.StartupPath + "\test.pdf"

        id = MBegin()
        If (id > 0) Then
            'Set PDF Information
            MInformation(id, "title", "subject", "author", "keywords", "creator", "producer")

            'Set Page Orientation
            MSetParam(id, PARAM_ROTATE, "", "", 90, 0)
            'Set X and Y Resolution
            MSetParam(id, PARAM_DPI, "", "", 300, 300)
            'Set page size
            MSetParam(id, PARAM_SIZE, "a4", "", 0, 0)

            MConvert(id, inFile, outFile)
            MEnd(id)
        End If

        MsgBox("Convert finished!")
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim id As Integer
        Dim fsize As Integer
        Dim fcolor As Integer
        Dim position As Integer
        Dim angle As Integer
        Dim xoff As Integer
        Dim yoff As Integer
        Dim background As Integer

        Dim inFile As String = Application.StartupPath + "\test2.px3"
        Dim outFile As String = Application.StartupPath + "\test_pdfa.pdf"

        id = MBegin()
        If (id > 0) Then
            fsize = 16
            fcolor = 255 'red
            position = 2 'Top-Center
            angle = 0
            xoff = 0
            yoff = 0
            background = 1
            MWatermark(id, "PDFA document", fsize, fcolor, position, angle, xoff, yoff, background)

            'Create a PDFA document
            MSetParam(id, PARAM_PDFA, "", "", 1, 0)

            MConvert(id, inFile, outFile)
            MEnd(id)
        End If

        MsgBox("Convert finished!")
    End Sub
End Class
