// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::LoadpcltopdfDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pcltopdf.dll");	

	m_hinstLib = LoadLibrary(path);
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMAddFiles = (MAddFiles *)GetProcAddress(m_hinstLib, "MAddFiles");
	if( pMAddFiles == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMConvertAll = (MConvertAll *)GetProcAddress(m_hinstLib, "MConvertAll");
	if( pMConvertAll == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMEncrypt = (MEncrypt *)GetProcAddress(m_hinstLib, "MEncrypt");
	if( pMEncrypt == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMInformation = (MInformation *)GetProcAddress(m_hinstLib, "MInformation");
	if( pMInformation == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreepcltopdfDll(); 
		return FALSE;
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::FreepcltopdfDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton1() 
{
	if( LoadpcltopdfDll() == FALSE ){
		MessageBox("Load pcltopdf.dll failed!");
		return;
	}

	char infile[256],infile2[256],outfile[256];
	GetModulePath(infile,"test.pcl");
	GetModulePath(infile2,"test2.px3");
	GetModulePath(outfile,"combine.pdf");	
	
	long id = pMBegin();
	if(id>0){
		long level = 40;
		long printing = 1;
		long copying = 1;
		long changing = 0;
		long adding = 0;
		//Set PDF Encrypt
		pMEncrypt(id,"password","password2",level,printing,copying,changing,adding);
		
		//Add files
		pMAddFiles(id, infile);
		pMAddFiles(id, infile2);

		//Combine all files into one pdf file
		pMConvertAll(id, outfile);
		pMEnd(id);
	}	

	FreepcltopdfDll();
	MessageBox("Convert finished!");
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton2() 
{
	if( LoadpcltopdfDll() == FALSE ){
		MessageBox("Load pcltopdf.dll failed!");
		return;
	}

	char infile[256],outfile[256];
	GetModulePath(infile,"test.pcl");
	GetModulePath(outfile,"test.pdf");

	long id = pMBegin();
	if(id>0){
		//Set PDF Information
		pMInformation(id,"title","subject","author","keywords","creator","producer");

		//Set Page Orientation
		pMSetParam(id,PARAM_ROTATE,NULL,NULL,90,0);
		//Set X and Y Resolution
		pMSetParam(id,PARAM_DPI,NULL,NULL,300,300);
		//Set page size
		pMSetParam(id,PARAM_SIZE,"a4",NULL,0,0);

		pMConvert(id,infile,outfile);
		pMEnd(id);
	}

	FreepcltopdfDll();
	MessageBox("Convert finished!");
}

void CExampleDlg::OnButton3() 
{
	if( LoadpcltopdfDll() == FALSE ){
		MessageBox("Load pcltopdf.dll failed!");
		return;
	}

	char infile[256],outfile[256];
	GetModulePath(infile,"test2.px3");
	GetModulePath(outfile,"test_pdfa.pdf");

	long id = pMBegin();
	if(id>0){
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		long angle=0;
		long xoff=0;
		long yoff=0;
		long background=1;
		//Stamping
		pMWatermark(id,"PDFA document",fsize,fcolor,position,angle,xoff,yoff,background);

		//Create a PDFA document
		pMSetParam(id,PARAM_PDFA,NULL,NULL,1,0);

		pMConvert(id,infile,outfile);
		pMEnd(id);
	}

	LoadpcltopdfDll();
	MessageBox("Convert finished!");		
}
